com.tibbo.aggregate.common.agent

## Class AgentContext

- java.lang.Object
- - com.tibbo.aggregate.common.context.AbstractContext
  - - com.tibbo.aggregate.common.agent.AgentContext

- All Implemented Interfaces:
    Context, EvaluationPoint, java.lang.Comparable

      public class AgentContext
      extends AbstractContext

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static java.lang.String` | `E_EVENT_CONFIRMED`
    `static java.lang.String` | `EF_EVENT_CONFIRMED_ID`
    `static TableFormat` | `EFT_EVENT_CONFIRMED`
    `static java.lang.String` | `F_ACKNOWLEDGE_EVENT`
    `static java.lang.String` | `F_CONFIRM_EVENT`
    `static java.lang.String` | `F_EXT_LOGIN`
    `static java.lang.String` | `F_GET_HISTORY`
    `static java.lang.String` | `F_LOGIN`
    `static java.lang.String` | `F_REGISTER`
    `static java.lang.String` | `F_SEND_BUFFERED_EVENTS`
    `static java.lang.String` | `F_SYNCHRONIZED`
    `static java.lang.String` | `FIF_ACKNOWLEDGE_EVENT_ACKNOWLEDGEMENT`
    `static java.lang.String` | `FIF_ACKNOWLEDGE_EVENT_AUTHOR`
    `static java.lang.String` | `FIF_ACKNOWLEDGE_EVENT_DATE`
    `static java.lang.String` | `FIF_ACKNOWLEDGE_EVENT_EVENT_DATA`
    `static java.lang.String` | `FIF_ACKNOWLEDGE_EVENT_ID`
    `static java.lang.String` | `FIF_CONFIRM_EVENT_ID`
    `static java.lang.String` | `FIF_LOGIN_CHALLENGE`
    `static TableFormat` | `FIFT_ACKNOWLEDGE_EVENT`
    `static TableFormat` | `FIFT_CONFIRM_EVENT`
    `static TableFormat` | `FIFT_LOGIN`
    `static java.lang.String` | `FOF_BUFFERED_EVENTS_SENT`
    `static java.lang.String` | `FOF_COMMAND_TIMEOUT`
    `static java.lang.String` | `FOF_GET_HISTORY_TIMESTAMP`
    `static java.lang.String` | `FOF_GET_HISTORY_VALUE`
    `static java.lang.String` | `FOF_GET_HISTORY_VARIABLE`
    `static java.lang.String` | `FOF_LOGIN_NAME`
    `static java.lang.String` | `FOF_LOGIN_OWNER`
    `static java.lang.String` | `FOF_LOGIN_RESPONSE`
    `static java.lang.String` | `FOF_PASSWORD`
    `static TableFormat` | `FOFT_EXT_LOGIN`
    `static TableFormat` | `FOFT_GET_HISTORY`
    `static TableFormat` | `FOFT_LOGIN`
    `static TableFormat` | `FOFT_REGISTER`
    `static TableFormat` | `FOFT_SEND_BUFFERED_EVENTS`
    `static java.lang.String` | `V_DATE`

    - ### Fields inherited from class com.tibbo.aggregate.common.context.AbstractContext

      `ACTION_DEF_FORMAT, CALLER_CONTROLLER_PROPERTY_DEBUG, CALLER_CONTROLLER_PROPERTY_NO_CHANGE_EVENTS, CALLER_CONTROLLER_PROPERTY_NO_STATISTICS, CALLER_CONTROLLER_PROPERTY_NO_UPDATED_EVENTS, CALLER_CONTROLLER_PROPERTY_NO_VALIDATION, currentSource, DEFAULT_EVENT_LEVEL, E_ACTION_ADDED, E_ACTION_REMOVED, E_ACTION_STATE_CHANGED, E_CHANGE, E_CHILD_ADDED, E_CHILD_REMOVED, E_DESTROYED, E_EVENT_ADDED, E_EVENT_REMOVED, E_FUNCTION_ADDED, E_FUNCTION_REMOVED, E_INFO, E_INFO_CHANGED, E_UPDATED, E_VARIABLE_ADDED, E_VARIABLE_REMOVED, E_VARIABLE_STATUS_CHANGED, ED_ACTION_ADDED, ED_ACTION_REMOVED, ED_ACTION_STATE_CHANGED, ED_CHANGE, ED_CHILD_ADDED, ED_CHILD_REMOVED, ED_DESTROYED, ED_EVENT_ADDED, ED_EVENT_REMOVED, ED_FUNCTION_ADDED, ED_FUNCTION_REMOVED, ED_INFO, ED_INFO_CHANGED, ED_UPDATED, ED_VARIABLE_ADDED, ED_VARIABLE_REMOVED, EF_ACTION_REMOVED_NAME, EF_CHANGE, EF_CHANGE_DATA, EF_CHANGE_FORMAT, EF_CHANGE_VALUE, EF_CHANGE_VARIABLE, EF_CHILD_ADDED_CHILD, EF_CHILD_REMOVED_CHILD, EF_EVENT_ADDED, EF_EVENT_REMOVED_NAME, EF_FUNCTION_ADDED, EF_FUNCTION_REMOVED_NAME, EF_INFO_INFO, EF_UPDATED, EF_UPDATED_UPDATE_ORIGINATOR, EF_UPDATED_USER, EF_UPDATED_VALUE, EF_UPDATED_VALUE_OLD, EF_UPDATED_VARIABLE, EF_UPDATED_VARIABLE_STATUS, EF_VARIABLE_REMOVED_NAME, EFT_ACTION_REMOVED, EFT_CHILD_ADDED, EFT_CHILD_REMOVED, EFT_EVENT_REMOVED, EFT_FUNCTION_REMOVED, EFT_INFO, EFT_VARIABLE_REMOVED, EVENT_DEFINITION_FORMAT, EXECUTOR_THREADS_PERCENT_FOR_VISITORS, F_BREAK_LOCK, F_COPY, F_COPY_TO_CHILDREN, F_FIRE_CONTEXT_EVENT, F_GET_ALIASES, F_GET_COPY_DATA, F_GET_VARIABLE_STATUS, F_LOCK, F_LOCKED_BY, F_UNLOCK, F_UPDATE_VARIABLE, FD_COPY, FD_COPY_TO_CHILDREN, FD_FIRE_CONTEXT_EVENT, FD_GET_ALIASES, FD_GET_COPY_DATA, FD_UPDATE_VARIABLE, FIELD_ED_DESCRIPTION, FIELD_ED_FORMAT, FIELD_ED_GROUP, FIELD_ED_HELP, FIELD_ED_ICON_ID, FIELD_ED_LEVEL, FIELD_ED_NAME, FIELD_FD_CONCURRENT, FIELD_FD_DESCRIPTION, FIELD_FD_GROUP, FIELD_FD_HELP, FIELD_FD_ICON_ID, FIELD_FD_INPUTFORMAT, FIELD_FD_NAME, FIELD_FD_OUTPUTFORMAT, FIELD_FD_PERMISSIONS, FIELD_REPLICATE_ERRORS, FIELD_REPLICATE_SUCCESSFUL, FIELD_REPLICATE_VARIABLE, FIELD_VD_ADD_PREVIOUS_VALUE_TO_VARIABLE_UPDATE_EVENT, FIELD_VD_CACHE_TIME, FIELD_VD_DESCRIPTION, FIELD_VD_FORMAT, FIELD_VD_GROUP, FIELD_VD_HELP, FIELD_VD_HELP_ID, FIELD_VD_ICON_ID, FIELD_VD_NAME, FIELD_VD_READABLE, FIELD_VD_SERVER_CACHING_MODE, FIELD_VD_WRITABLE, FIF_COPY_DATA_GROUP, FIF_COPY_DATA_RECIPIENTS, FIF_COPY_DATA_RECIPIENTS_RECIPIENT, FIF_FIRE_EVENT_DATA, FIF_FIRE_EVENT_EVENT, FIF_FIRE_EVENT_LEVEL, FIF_LOCK_PROPERTIES_EDITOR_UUID, FIF_REPLICATE_FIELDS_DESCRIPTION, FIF_REPLICATE_FIELDS_NAME, FIF_REPLICATE_FIELDS_REPLICATE, FIF_UNLOCK_PROPERTIES_EDITOR_UUID, FIF_VISIBLE_CHILDREN_CONTEXT_MASK, FIF_VISIBLE_CHILDREN_COUNT, FIF_VISIBLE_CHILDREN_FILTER_EXPRESSION, FIF_VISIBLE_CHILDREN_GLOBAL_FILTER, FIF_VISIBLE_CHILDREN_OFFSET, FIF_VISIBLE_CHILDREN_PROPERTY_FILTERS, FIF_VISIBLE_CHILDREN_SMART_FILTER_EXPRESSION, FIFT_FIRE_CONTEXT_EVENT, FIFT_GET_COPY_DATA, FIFT_GET_COPY_DATA_RECIPIENTS, FIFT_GET_VARIABLE_STATUS, FIFT_LOCK, FIFT_REPLICATE_FIELDS, FIFT_UNLOCK, FIFT_UPDATE_VARIABLE, FIFT_VISIBLE_CHILDREN, FOF_COPY_DATA_DESCRIPTION, FOF_COPY_DATA_FIELDS, FOF_COPY_DATA_NAME, FOF_COPY_DATA_REPLICATE, FOF_COPY_DATA_VALUE, FOF_FIRE_EVENT_ID, FOF_GET_ALIASES_ALIAS_NAME, FOF_GET_ALIASES_ENTITY_TYPE, FOF_GET_ALIASES_NAME, FOF_LOCK_OWNER_NAME, FOF_LOCKED_BY_OWNER_NAME, FOF_UNLOCK_UNLOCKED, FOF_VISIBLE_CHILDREN_BATCH, FOF_VISIBLE_CHILDREN_TOTAL_COUNT, FOFT_FIRE_CONTEXT_EVENT, FOFT_GET_ALIASES, FOFT_LOCK, FOFT_LOCKED_BY, FOFT_UNLOCK, FOFT_VISIBLE_CHILDREN, FUNCTION_DEFINITION_FORMAT, INDEX_HIGH, INDEX_HIGHER, INDEX_HIGHEST, INDEX_LOW, INDEX_LOWER, INDEX_LOWEST, INDEX_NORMAL, INDEX_VERY_HIGH, INDEX_VERY_LOW, INFO_DEFINITION_FORMAT, ready, REPLICATE_INPUT_FORMAT, REPLICATE_OUTPUT_FORMAT, REPLICATE_TO_CHILDREN_OUTPUT_FORMAT, RESOURCE_MASKS_FORMAT, SORT_THRESHOLD, V_ACTIONS, V_CHILDREN, V_EVENTS, V_FUNCTIONS, V_INFO, V_UPDATE_VARIABLE, V_UPDATE_VARIABLE_EXPRESSION, V_VARIABLE_NAME, V_VARIABLE_STATUSES, V_VARIABLES, VARIABLE_DEFINITION_FORMAT, VD_ACTIONS, VD_CHILDREN, VD_EVENTS, VD_FUNCTIONS, VD_INFO, VD_VARIABLES, VF_CHILDREN_IS_CONTAINER, VF_CHILDREN_NAME, VF_INFO_DESCRIPTION, VF_INFO_GROUP, VF_INFO_ICON, VF_INFO_LOCAL_ROOT, VF_INFO_MAPPED, VF_INFO_PEER_PRIMARY_ROOT, VF_INFO_PEER_ROOT, VF_INFO_REMOTE_PATH, VF_INFO_REMOTE_ROOT, VF_INFO_TYPE, VF_VARIABLE_STATUSES_COMMENT, VF_VARIABLE_STATUSES_NAME, VF_VARIABLE_STATUSES_STATUS, VF_VISIBLE_CHILDREN_PROPERTY_FILTERS_PROPERTY_NAME, VF_VISIBLE_CHILDREN_PROPERTY_FILTERS_PROPERTY_VALUE, VFT_CHILDREN, VFT_VISIBLE_CHILDREN`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `AgentContext(RemoteServer server, java.lang.String name, boolean eventConfirmation)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected void` | `acknowledgeEvent(java.lang.Long id, java.util.Date date, java.lang.String author, java.lang.String acknowledgement, DataTable data)`
    `void` | `addAsset(DeviceAssetDefinition asset)`
    `protected void` | `confirmEvent(java.lang.Long id)`
    `java.util.List<DeviceAssetDefinition>` | `getAssets()`
    `protected java.util.List<HistoricalValue>` | `getHistory()`
    `RemoteServer` | `getServer()`
    `boolean` | `isSynchronized()`
    `protected int` | `sendBufferedEvents()` Implementations of this method should send previously buffered events to the server by calling fireEvent().
    `void` | `setAssets(java.util.List<DeviceAssetDefinition> assets)`
    `void` | `setFormatCache(FormatCache formatCache)`
    `void` | `setKnownFormatCollector(KnownFormatCollector knownFormatCollector)`
    `void` | `setSynchronized(boolean isSynchronized)`
    `void` | `setupMyself()`

    - ### Methods inherited from class com.tibbo.aggregate.common.context.AbstractContext

      `accept, actDefFromDataRecord, actDefToDataRecord, addActionDefinition, addAlias, addChild, addChild, addChild, addChild, addEventDefinition, addEventListener, addEventListener, addFunctionDefinition, addVariableDefinition, addVariableRecord, addVariableRecord, applyCachedFormat, awaitInitialized, callFcopy, callFcopyToChildren, callFfireContextEvent, callFgetAliases, callFgetCopyData, callFunction, callFunction, callFunction, callFunction, callFunction, callFunction, callFunction, callFunction, callFunctionImpl, callFupdateVariable, checkPermissions, checkPermissions, clearVariableStatuses, compareTo, copyTo, createContextInfoTable, decodeFormat, destroy, destroyChild, destroyChildren, enableStatus, enableVariableStatuses, encodeFormat, ensureVariableStatuses, equals, evtDefFromDataRecord, evtDefToDataRecord, evtDefToDataRecord, executeDefaultGetter, executeDefaultGetter, executeDefaultGetter, executeDefaultGetterImpl, executeDefaultSetter, executeDefaultSetter, executeDefaultSetterImpl, executeTasks, executeTasks, executeTasksConcurrently, fetchVariableStatuses, fireChangeEvent, fireEvent, fireEvent, fireEvent, fireEvent, fireEvent, fireEvent, fireEvent, fireEvent, fireEvent, fireEvent, fireEvent, fireEvent, fireEvent, fireEvent, fireEventAdded, fireFunctionAdded, fireStatusChanged, fireUpdatedEvent, fireVariableAdded, funcDefFromDataRecord, funcDefToDataRecord, funcDefToDataRecord, get, get, getActionDefinition, getActionDefinition, getActionDefinitions, getActionDefinitions, getActionDefinitions, getChangeEventDefinition, getChild, getChild, getChildren, getChildren, getChildrenLock, getChildrenViewPermissions, getContextManager, getDefaultActionDefinition, getDefaultValue, getDescription, getEventData, getEventDataView, getEventDefinition, getEventDefinition, getEventDefinitions, getEventDefinitions, getEventDefinitions, getEventDefinitions, getEventDefinitions, getEventHistory, getEventProcessingCallerController, getEventProcessingRule, getFunctionData, getFunctionDataView, getFunctionDefinition, getFunctionDefinition, getFunctionDefinitions, getFunctionDefinitions, getFunctionDefinitions, getFunctionDefinitions, getFunctionDefinitions, getGroup, getIconId, getIndex, getLocalPrimaryRoot, getLocalRoot, getMappedChildren, getMappedChildren, getName, getParent, getPath, getPeerPath, getPeerRoot, getPermissionChecker, getPermissions, getRemotePath, getRemoteRoot, getRoot, getStatus, getType, getVactions, getVariable, getVariable, getVariable, getVariableClone, getVariableData, getVariableDataView, getVariableDefinition, getVariableDefinition, getVariableDefinitions, getVariableDefinitions, getVariableDefinitions, getVariableDefinitions, getVariableDefinitions, getVariableImpl, getVariableObject, getVariableStatus, getVchildren, getVevents, getVfunctions, getVinfo, getVisibleChildren, getVisibleChildren, getVvariables, hashCode, hasMappedChild, hasParent, hasVisibleChild, isAllowSetterExecution, isAllowUpdatedEvents, isBelongedToTheGroup, isChildrenConcurrencyEnabled, isChildrenSortingEnabled, isContainer, isDebuggingEvaluations, isDistributed, isEntityProtected, isFireUpdateEvents, isInitializedChildren, isInitializedEvents, isInitializedFunctions, isInitializedInfo, isInitializedStatus, isInitializedVariables, isInstallationAllowed, isMapped, isPermissionCheckingEnabled, isProtected, isProxy, isSetupComplete, isStarted, isStopped, logAsyncSessionExecutionAction, move, moveFinalize, moveInternal, movePrepare, obtainFormatCache, onIllegalDefinitionUpdated, persistVariableStatuses, postEvent, processBindings, processEvaluation, processEvaluationError, removeActionDefinition, removeChild, removeChild, removeEventDefinition, removeEventListener, removeFromParent, removeFunctionDefinition, removeValues, removeVariableDefinition, removeVariableRecords, reorderChild, replicateVariableOnCopy, saveVariableStatuses, setChildrenConcurrencyEnabled, setChildrenSortingEnabled, setChildrenViewPermissions, setContextManager, setDescription, setFireUpdateEvents, setGroup, setIconId, setIndex, setName, setParent, setPermissionChecker, setPermissionCheckingEnabled, setPermissions, setStatus, setType, setup, setup, setupChildren, setupEvents, setupFunctions, setupPermissions, setupVariables, setValueCheckingEnabled, setVariable, setVariable, setVariable, setVariable, setVariable, setVariableField, setVariableField, setVariableField, setVariableImpl, shouldSeeChild, start, stop, teardown, toDetailedString, toString, updateEvent, updateEventDefinitions, updateFunctionAndAction, updateFunctionDefinitions, updatePrepare, updateVariableDefinitions, updateVariableStatus, validateVariableValueToSet, varDefFromDataRecord, varDefToDataRecord, varDefToDataRecord, variableUpdated`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface com.tibbo.aggregate.common.context.Context

      `setVariableField`

- - ### Field Detail

    - #### V_DATE

          public static final java.lang.String V_DATE

      See Also:
        Constant Field Values

    - #### F_LOGIN

          public static final java.lang.String F_LOGIN

      See Also:
        Constant Field Values

    - #### F_EXT_LOGIN

          public static final java.lang.String F_EXT_LOGIN

      See Also:
        Constant Field Values

    - #### F_REGISTER

          public static final java.lang.String F_REGISTER

      See Also:
        Constant Field Values

    - #### F_SYNCHRONIZED

          public static final java.lang.String F_SYNCHRONIZED

      See Also:
        Constant Field Values

    - #### F_CONFIRM_EVENT

          public static final java.lang.String F_CONFIRM_EVENT

      See Also:
        Constant Field Values

    - #### F_ACKNOWLEDGE_EVENT

          public static final java.lang.String F_ACKNOWLEDGE_EVENT

      See Also:
        Constant Field Values

    - #### F_GET_HISTORY

          public static final java.lang.String F_GET_HISTORY

      See Also:
        Constant Field Values

    - #### F_SEND_BUFFERED_EVENTS

          public static final java.lang.String F_SEND_BUFFERED_EVENTS

      See Also:
        Constant Field Values

    - #### E_EVENT_CONFIRMED

          public static final java.lang.String E_EVENT_CONFIRMED

      See Also:
        Constant Field Values

    - #### FIF_LOGIN_CHALLENGE

          public static final java.lang.String FIF_LOGIN_CHALLENGE

      See Also:
        Constant Field Values

    - #### FIF_CONFIRM_EVENT_ID

          public static final java.lang.String FIF_CONFIRM_EVENT_ID

      See Also:
        Constant Field Values

    - #### FIF_ACKNOWLEDGE_EVENT_ID

          public static final java.lang.String FIF_ACKNOWLEDGE_EVENT_ID

      See Also:
        Constant Field Values

    - #### FIF_ACKNOWLEDGE_EVENT_DATE

          public static final java.lang.String FIF_ACKNOWLEDGE_EVENT_DATE

      See Also:
        Constant Field Values

    - #### FIF_ACKNOWLEDGE_EVENT_AUTHOR

          public static final java.lang.String FIF_ACKNOWLEDGE_EVENT_AUTHOR

      See Also:
        Constant Field Values

    - #### FIF_ACKNOWLEDGE_EVENT_ACKNOWLEDGEMENT

          public static final java.lang.String FIF_ACKNOWLEDGE_EVENT_ACKNOWLEDGEMENT

      See Also:
        Constant Field Values

    - #### FIF_ACKNOWLEDGE_EVENT_EVENT_DATA

          public static final java.lang.String FIF_ACKNOWLEDGE_EVENT_EVENT_DATA

      See Also:
        Constant Field Values

    - #### FOF_LOGIN_OWNER

          public static final java.lang.String FOF_LOGIN_OWNER

      See Also:
        Constant Field Values

    - #### FOF_LOGIN_NAME

          public static final java.lang.String FOF_LOGIN_NAME

      See Also:
        Constant Field Values

    - #### FOF_LOGIN_RESPONSE

          public static final java.lang.String FOF_LOGIN_RESPONSE

      See Also:
        Constant Field Values

    - #### FOF_PASSWORD

          public static final java.lang.String FOF_PASSWORD

      See Also:
        Constant Field Values

    - #### FOF_COMMAND_TIMEOUT

          public static final java.lang.String FOF_COMMAND_TIMEOUT

      See Also:
        Constant Field Values

    - #### FOF_GET_HISTORY_VARIABLE

          public static final java.lang.String FOF_GET_HISTORY_VARIABLE

      See Also:
        Constant Field Values

    - #### FOF_GET_HISTORY_TIMESTAMP

          public static final java.lang.String FOF_GET_HISTORY_TIMESTAMP

      See Also:
        Constant Field Values

    - #### FOF_GET_HISTORY_VALUE

          public static final java.lang.String FOF_GET_HISTORY_VALUE

      See Also:
        Constant Field Values

    - #### FOF_BUFFERED_EVENTS_SENT

          public static final java.lang.String FOF_BUFFERED_EVENTS_SENT

      See Also:
        Constant Field Values

    - #### EF_EVENT_CONFIRMED_ID

          public static final java.lang.String EF_EVENT_CONFIRMED_ID

      See Also:
        Constant Field Values

    - #### FIFT_LOGIN

          public static final TableFormat FIFT_LOGIN

    - #### FOFT_LOGIN

          public static final TableFormat FOFT_LOGIN

    - #### FOFT_EXT_LOGIN

          public static final TableFormat FOFT_EXT_LOGIN

    - #### FOFT_REGISTER

          public static final TableFormat FOFT_REGISTER

    - #### FOFT_GET_HISTORY

          public static final TableFormat FOFT_GET_HISTORY

    - #### FOFT_SEND_BUFFERED_EVENTS

          public static final TableFormat FOFT_SEND_BUFFERED_EVENTS

    - #### FIFT_CONFIRM_EVENT

          public static final TableFormat FIFT_CONFIRM_EVENT

    - #### FIFT_ACKNOWLEDGE_EVENT

          public static final TableFormat FIFT_ACKNOWLEDGE_EVENT

    - #### EFT_EVENT_CONFIRMED

          public static final TableFormat EFT_EVENT_CONFIRMED

  - ### Constructor Detail

    - #### AgentContext

          public AgentContext(RemoteServer server,
                              java.lang.String name,
                              boolean eventConfirmation)

  - ### Method Detail

    - #### setupMyself

          public void setupMyself()
                           throws ContextException

      Overrides:
        `setupMyself` in class `AbstractContext`
      Throws:
        `ContextException`

    - #### addAsset

          public void addAsset(DeviceAssetDefinition asset)

    - #### getAssets

          public java.util.List<DeviceAssetDefinition> getAssets()

    - #### setAssets

          public void setAssets(java.util.List<DeviceAssetDefinition> assets)

    - #### confirmEvent

          protected void confirmEvent(java.lang.Long id)

    - #### acknowledgeEvent

          protected void acknowledgeEvent(java.lang.Long id,
                                          java.util.Date date,
                                          java.lang.String author,
                                          java.lang.String acknowledgement,
                                          DataTable data)

    - #### isSynchronized

          public boolean isSynchronized()

    - #### setSynchronized

          public void setSynchronized(boolean isSynchronized)

    - #### getServer

          public RemoteServer getServer()

    - #### setFormatCache

          public void setFormatCache(FormatCache formatCache)

    - #### setKnownFormatCollector

          public void setKnownFormatCollector(KnownFormatCollector knownFormatCollector)

    - #### getHistory

          protected java.util.List<HistoricalValue> getHistory()

    - #### sendBufferedEvents

          protected int sendBufferedEvents()

      Implementations of this method should send previously buffered events to the server by calling fireEvent().
      Returns:
        Number of events sent